# CalcConfigurations

Order system configurations and items

## GET /v3/calc/categories

> Get all shop categories

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcConfigurations","description":"Order system configurations and items"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CalcCategory":{"type":"object","required":["id","name"],"properties":{"id":{"type":"integer","format":"integer","description":"ID of a category"},"name":{"type":"string","format":"","description":"Name of a category"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/categories":{"get":{"tags":["CalcConfigurations"],"summary":"Get all shop categories","operationId":"getCalcCategories","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CalcCategory"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/calc/configs/{categoryName}

> Get all configurations for the given shop category

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcConfigurations","description":"Order system configurations and items"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CalcConfig":{"type":"object","required":["id","tag","locationId","price","setup","flags","bwPriceDedi","bwPriceColo","fixed","noDowngrade","instantDeliverable","groups"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration ID"},"tag":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration tag"},"locationId":{"type":"integer","format":"integer","description":"Location ID, as provided by /locations"},"price":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration price in cents"},"setup":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration setup price in cents"},"flags":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration flags\nIMMUTABLE         1;\nINSTANT_CONFIG    2;\nALLOW_DOWNGRADE   4;\nIS_DEAL           8;\nON_DEAL_PAGE      16;\nCOLO_NO_CONN      32;\nPRIVATE_CONFIG    64;"},"bwPriceDedi":{"type":"integer","format":"integer","description":"TB price for dedicated servers, in cents"},"bwPriceColo":{"type":"integer","format":"integer","description":"TB price for colocation, in cents"},"fixed":{"type":"boolean","description":"Whether this configuration is adjustable"},"noDowngrade":{"type":"boolean","description":"Whether items in this configuration can be downgraded"},"instantDeliverable":{"type":"boolean","description":"Whether this configuration can be setup instantly and automatically (low wait time)"},"groups":{"type":"array","items":{"$ref":"#/components/schemas/CalcGroup"},"description":"All item groups for this configuration"}},"additionalProperties":false},"CalcGroup":{"type":"object","required":["id","name","code","type","fixed","step","flags","noDowngrade","displayOrder","dependencyGroupId","dependencyItemIds","notes","items","defaultItemId"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group ID"},"name":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group name"},"code":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group code"},"type":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group type (a human readable unique identifier)"},"fixed":{"type":"boolean","description":"Whether items in this configuration group are adjustable"},"step":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group divider (for visual differentiation between related groups)"},"flags":{"type":"integer","format":"integer","description":"FLAG_HASQUANTITY                  1\nFLAG_HASPRICE                     2\nFLAG_ALLOW_EMPTY_SELECTION        4\nFLAG_INCLUDE_ON_INVOICE_IF_EMPTY  8\nFLAG_NOTE_ACTIVE                  16\nFLAG_APPLY_PERIOD_DISCOUNT        32\nFLAG_EXCLUDE_FROM_UPGRADES        64"},"noDowngrade":{"type":"boolean","description":"Whether items in this configuration group can be downgraded"},"displayOrder":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group display order"},"dependencyGroupId":{"type":"integer","format":"integer","description":"If > 0, this group will only relevant / shown if the dependency group and/or item is selected."},"dependencyItemIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"If dependencyGroupId > 0, this group will only relevant / shown if (one of) these dependencyItemIds are selected."},"notes":{"type":"string","format":"","description":"Optional notes for a group, for displaying purposes."},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcItem"},"description":"All items for this configuration group"},"defaultItemId":{"type":"integer","format":"integer","description":"Default item in a group"}},"additionalProperties":false},"CalcItem":{"type":"object","required":["id","code","name","shortName","ident","quantity","specifications","flags","price","setupPrice","priceLinkGroupId","priceLinkPercentage","displayOrder","excludeConfigs","excludeLocationIds"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration item ID"},"code":{"type":"string","format":"","description":"ApplicationInstanceConfiguration item code"},"name":{"type":"string","format":"","description":"Item name"},"shortName":{"type":"string","format":"","description":"Item name short"},"ident":{"type":"string","format":"","description":"Item human readable unique identifier"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"},"specifications":{"type":"array","items":{"$ref":"#/components/schemas/CalcItemSpecification"},"description":"Item specifications"},"flags":{"type":"integer","format":"integer","description":"FLAG_NOTE_ACTIVE 1"},"price":{"type":"integer","format":"integer","description":"Item price in cents"},"setupPrice":{"type":"integer","format":"integer","description":"Item setup price in cents"},"priceLinkGroupId":{"type":"integer","format":"integer","description":"Item price is dependent on the price of this group or the entire order.\nIf -1, the price is a percentage (priceLinkPercentage) of the order.\nIf > 0, the price is a percentage (priceLinkPercentage) of the indicated group."},"priceLinkPercentage":{"type":"number","format":"float","description":"The percentage as refered to by priceLinkGroupId description."},"displayOrder":{"type":"integer","format":"integer","description":"Item display order"},"excludeConfigs":{"type":"array","items":{"type":"integer","format":"integer"},"description":"ApplicationInstanceConfiguration IDs from which this item must be excluded."},"excludeLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"Location IDs from which this item must be excluded."}},"additionalProperties":false},"CalcItemSpecification":{"type":"object","required":["id","name","value","dataType","mandatory"],"properties":{"id":{"type":"integer","format":"integer","description":"Item specification ID"},"name":{"type":"string","format":"","description":"Item specification name"},"value":{"type":"string","format":"","description":"Item specification value"},"dataType":{"type":"string","format":"","description":"Item specification data type (int, float, string)"},"mandatory":{"type":"integer","format":"integer","description":"Whether this item specification is mandatory"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/configs/{categoryName}":{"get":{"tags":["CalcConfigurations"],"summary":"Get all configurations for the given shop category","operationId":"getCalcConfig","parameters":[{"name":"categoryName","in":"path","description":"Category name, one of /calc/categories","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CalcConfig"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"If an unknown category has been provided"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/calc/items/{categoryName}

> Get all groups and items of the given category

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcConfigurations","description":"Order system configurations and items"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CalcGroup":{"type":"object","required":["id","name","code","type","fixed","step","flags","noDowngrade","displayOrder","dependencyGroupId","dependencyItemIds","notes","items","defaultItemId"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group ID"},"name":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group name"},"code":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group code"},"type":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group type (a human readable unique identifier)"},"fixed":{"type":"boolean","description":"Whether items in this configuration group are adjustable"},"step":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group divider (for visual differentiation between related groups)"},"flags":{"type":"integer","format":"integer","description":"FLAG_HASQUANTITY                  1\nFLAG_HASPRICE                     2\nFLAG_ALLOW_EMPTY_SELECTION        4\nFLAG_INCLUDE_ON_INVOICE_IF_EMPTY  8\nFLAG_NOTE_ACTIVE                  16\nFLAG_APPLY_PERIOD_DISCOUNT        32\nFLAG_EXCLUDE_FROM_UPGRADES        64"},"noDowngrade":{"type":"boolean","description":"Whether items in this configuration group can be downgraded"},"displayOrder":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group display order"},"dependencyGroupId":{"type":"integer","format":"integer","description":"If > 0, this group will only relevant / shown if the dependency group and/or item is selected."},"dependencyItemIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"If dependencyGroupId > 0, this group will only relevant / shown if (one of) these dependencyItemIds are selected."},"notes":{"type":"string","format":"","description":"Optional notes for a group, for displaying purposes."},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcItem"},"description":"All items for this configuration group"},"defaultItemId":{"type":"integer","format":"integer","description":"Default item in a group"}},"additionalProperties":false},"CalcItem":{"type":"object","required":["id","code","name","shortName","ident","quantity","specifications","flags","price","setupPrice","priceLinkGroupId","priceLinkPercentage","displayOrder","excludeConfigs","excludeLocationIds"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration item ID"},"code":{"type":"string","format":"","description":"ApplicationInstanceConfiguration item code"},"name":{"type":"string","format":"","description":"Item name"},"shortName":{"type":"string","format":"","description":"Item name short"},"ident":{"type":"string","format":"","description":"Item human readable unique identifier"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"},"specifications":{"type":"array","items":{"$ref":"#/components/schemas/CalcItemSpecification"},"description":"Item specifications"},"flags":{"type":"integer","format":"integer","description":"FLAG_NOTE_ACTIVE 1"},"price":{"type":"integer","format":"integer","description":"Item price in cents"},"setupPrice":{"type":"integer","format":"integer","description":"Item setup price in cents"},"priceLinkGroupId":{"type":"integer","format":"integer","description":"Item price is dependent on the price of this group or the entire order.\nIf -1, the price is a percentage (priceLinkPercentage) of the order.\nIf > 0, the price is a percentage (priceLinkPercentage) of the indicated group."},"priceLinkPercentage":{"type":"number","format":"float","description":"The percentage as refered to by priceLinkGroupId description."},"displayOrder":{"type":"integer","format":"integer","description":"Item display order"},"excludeConfigs":{"type":"array","items":{"type":"integer","format":"integer"},"description":"ApplicationInstanceConfiguration IDs from which this item must be excluded."},"excludeLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"Location IDs from which this item must be excluded."}},"additionalProperties":false},"CalcItemSpecification":{"type":"object","required":["id","name","value","dataType","mandatory"],"properties":{"id":{"type":"integer","format":"integer","description":"Item specification ID"},"name":{"type":"string","format":"","description":"Item specification name"},"value":{"type":"string","format":"","description":"Item specification value"},"dataType":{"type":"string","format":"","description":"Item specification data type (int, float, string)"},"mandatory":{"type":"integer","format":"integer","description":"Whether this item specification is mandatory"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/items/{categoryName}":{"get":{"tags":["CalcConfigurations"],"summary":"Get all groups and items of the given category","operationId":"getCalcItem","parameters":[{"name":"categoryName","in":"path","description":"Category name, one of /calc/categories","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CalcGroup"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"If an unknown category has been provided"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/calc/locations

> Get all the availability locations per calc category

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"tags":[{"name":"CalcConfigurations","description":"Order system configurations and items"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"CalcCategoryLocation":{"type":"object","required":["categoryIds","locationId","countryName","countryNameShort","regionId","regionName","continent","city","locationBwPriceDedi","locationBwOverusePriceDedi","locationBwPriceColo","locationBwOverusePriceColo"],"properties":{"categoryIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"Category IDs"},"locationId":{"type":"integer","format":"integer","description":"Location ID"},"countryName":{"type":"string","format":"","description":"Name of the country of this location"},"countryNameShort":{"type":"string","format":"","description":"Name of the country of this location"},"regionId":{"type":"integer","format":"integer","description":"Region ID"},"regionName":{"type":"string","format":"","description":"Name of the region this location is situated in (regions are smaller than continents, but may be a whole continent)."},"continent":{"type":"string","format":"","description":"Name of the continent of this location"},"city":{"type":"string","format":"","description":"Name of the city of this location"},"locationBwPriceDedi":{"type":"integer","format":"integer","description":"Dedicated server bandwidth price per TB for this location, in cents"},"locationBwOverusePriceDedi":{"type":"integer","format":"integer","description":"Dedicated server bandwidth overuse price per TB for this location, in cents"},"locationBwPriceColo":{"type":"integer","format":"integer","description":"Colocation bandwidth price per TB for this location, in cents"},"locationBwOverusePriceColo":{"type":"integer","format":"integer","description":"Colocation bandwidth overuse price per TB for this location, in cents"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/calc/locations":{"get":{"tags":["CalcConfigurations"],"summary":"Get all the availability locations per calc category","operationId":"getCalcLocations","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CalcCategoryLocation"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.i3d.net/api-references/general/calcconfigurations.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
